<template>
  <div
    class="flex is-direction:column is-spaced:center is-aligned:center fixed-background"
    ref="screen"
  >
    <fixed-copy>
      <template v-slot:default>
        <span class="-salt">E</span>L<span class="-salt">E</span>VATI<span
          class="-ss02"
          >N</span
        >G A VISUAL LA<span class="-ss02">N</span>GUAG<span class="-salt"
          >E</span
        >
        FOR TH<span class="-salt">E</span> &nbsp;<span class="-ss02">M</span
        >ASS<span class="-salt">E</span>S
      </template>
    </fixed-copy>
    <div class="screen is-forground"></div>
  </div>
  <div class="fix-view" ref="viewer"></div>
  <div :style="styleObject" class="fixed-background fixed-outer"></div>
</template>

<script>
import FixedCopy from "../Copy/FixedCopy";

export default {
  components: {
    FixedCopy
  },
  created() {
    window.addEventListener("scroll", this.handleScroll);
  },
  beforeUnmount() {
    window.removeEventListener("scroll", this.handleScroll);
  },
  data() {
    return {
      styleObject: {
        backgroundImage: "url(" + this.getImage("am_back_1.png") + ")",
        backgroundColor: null,
        // maxHeight: null,
        transform: null
      }
    };
  },
  methods: {
    getImage(path) {
      return require(`@/assets/img/${path}`);
    },
    handleScroll() {
      const body_top = document.body.getBoundingClientRect().top;
      const viewer_bottom = this.$refs.viewer.getBoundingClientRect().bottom;
      if (viewer_bottom < 0 || body_top > 0) {
        this.styleObject.backgroundImage = null;
        this.styleObject.backgroundColor = "transparent";
        this.styleObject.transform = "translateY(" + -100 + "%)";
      } else {
        this.styleObject.backgroundImage =
          "url(" + this.getImage("am_back_1.png") + ")";
        this.styleObject.backgroundColor = null;
        this.styleObject.transform = null;
      }
    }
  }
};
</script>
<style lang="scss" scoped>
$background-padding: 33vh;
.fixed-background {
  position: relative;
  z-index: 2;
  background-attachment: scroll;
  background-repeat: no-repeat;
  background-position: top;
  background-size: cover;
  // background-size: cover;
  min-height: initial;
  // padding: $background-padding 0;
  z-index: 3;
  padding: 25vh 0;
  @media all and (min-width: 768px) {
    padding: 25vh 0;
  }
  @media all and (min-width: 1024px) {
    padding: 36vh 0;
  }
  @media all and (min-width: 1280px) {
    padding: 50vh 0;
  }
}
.fix-view {
  // padding: $background-padding 0;
  background-color: transparent;
  display: block;
  padding: 25vh 0;
  @media all and (min-width: 768px) {
    padding: 35vh 0;
  }
  @media all and (min-width: 1024px) {
    padding: 36vh 0;
  }
  @media all and (min-width: 1280px) {
    padding: 50vh 0;
  }
}
.fixed-outer {
  z-index: 1;
  position: fixed;
  top: 0;
  // width: 100%;
  right: 0;
  bottom: 0;
  left: 0;
}

.screen {
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  background-color: rgba(black, 0.8);
  z-index: -1;
}
</style>
